package actordemo

import scala.actors.Actor
import scala.actors.Actor.actor
import scala.actors.Actor.self
import scala.actors.TIMEOUT

object SimpleDemo {

  case class Message(s: String)

  class A1 extends Actor {

    def act() {
      while (true) {
        receive {
          case Message(s) => println("Msg:" + s + " from " + sender)
          case 'STOP =>
            println("STOP!!!"); exit //return
          case z => { println(z); }
        }
      }
    }

  }

  def main(args: Array[String]) {

    val a1 = new A1
    a1.start

    a1 ! "foo"
    a1 ! "bar"
    a1 ! Message("my msg")
    a1 ! 'STOP
    a1 ! "foobar"
  }

  val timer = actor {
    while (true) {
      self.receiveWithin(1000) {
        case TIMEOUT => { println("timeout") }
      }
    }
  }
  timer.start

}